#include "geometry_shapes.h"
#include "sgg/graphics.h"

// Μέγεθος παραθύρου
const float WINDOW_WIDTH = 800;
const float WINDOW_HEIGHT = 600;

// Συνάρτηση σχεδίασης
void draw() {
    graphics::Brush brush;

    // Καθαρισμός του παραθύρου
    brush.fill_color[0] = 0.9f;
    brush.fill_color[1] = 0.9f;
    brush.fill_color[2] = 0.9f;
    graphics::drawRect(WINDOW_WIDTH / 2, WINDOW_HEIGHT / 2, WINDOW_WIDTH, WINDOW_HEIGHT, brush);

    // Ρύθμιση χρώματος για τα σχήματα
    brush.fill_color[0] = 0.2f;
    brush.fill_color[1] = 0.6f;
    brush.fill_color[2] = 0.8f;

    // Σχεδίαση τετραγώνου
    GeometryShapes::drawSquare(100, 100, 50, brush);

    // Σχεδίαση παραλληλογράμμου
    GeometryShapes::drawRectangle(250, 100, 80, 50, brush);

    // Σχεδίαση ρόμβου
    GeometryShapes::drawRhombus(400, 100, 80, 50, brush);

    // Σχεδίαση ορθογώνιου παραλληλογράμμου
    GeometryShapes::drawParallelogram(550, 100, 100, 50, brush);

    // Σχεδίαση τραπεζίου
    GeometryShapes::drawTrapezoid(700, 100, 60, 100, 50, brush);

    // Αλλαγή χρώματος για τα τρίγωνα
    brush.fill_color[0] = 0.8f;
    brush.fill_color[1] = 0.3f;
    brush.fill_color[2] = 0.5f;

    // Σχεδίαση απλού τριγώνου
    GeometryShapes::drawTriangle(100, 250, 150, 250, 125, 200, brush);

    // Σχεδίαση ορθογώνιου τριγώνου
    GeometryShapes::drawRightTriangle(250, 250, 50, 30, brush);

    // Σχεδίαση ισοσκελούς τριγώνου
    GeometryShapes::drawIsoscelesTriangle(400, 250, 60, 40, brush);

    // Σχεδίαση ισοπλεύρου τριγώνου
    GeometryShapes::drawEquilateralTriangle(550, 250, 50, brush);

    // Σχεδίαση κανονικού πολυγώνου (πεντάγωνο)
    GeometryShapes::drawRegularPolygon(700, 250, 5, 30, brush);
}

// Συνάρτηση main
int main() {
    // Δημιουργία παραθύρου
    graphics::createWindow(WINDOW_WIDTH, WINDOW_HEIGHT, "Geometry Shapes Example");

    // Ορισμός της συνάρτησης σχεδίασης
    graphics::setDrawFunction(draw);

    // Εκκίνηση του κυκλώματος μηνυμάτων
    graphics::startMessageLoop();

    return 0;
}