#include "three_d_shapes.h" // Συμπερίληψη της βιβλιοθήκης για τα τρισδιάστατα σχήματα
#include "sgg/graphics.h"    // Συμπερίληψη της βιβλιοθήκης γραφικών sgg
#include <cmath>

// Διαστάσεις παραθύρου
const float WINDOW_WIDTH = 800;
const float WINDOW_HEIGHT = 600;

void draw() {
    graphics::Brush brush;

    // Ορισμός χρώματος για τον κύβο
    brush.fill_color[0] = 0.2f;
    brush.fill_color[1] = 0.6f;
    brush.fill_color[2] = 0.8f;
    ThreeDShapes::drawCube(150, 150, 100, brush); // Σχεδίαση κύβου

    // Ορισμός χρώματος για το παραλληλεπίπεδο
    brush.fill_color[0] = 0.8f;
    brush.fill_color[1] = 0.5f;
    brush.fill_color[2] = 0.2f;
    ThreeDShapes::drawCuboid(400, 150, 120, 80, 60, brush); // Σχεδίαση παραλληλεπιπέδου

    // Ορισμός χρώματος για τον κώνο
    brush.fill_color[0] = 1.0f;
    brush.fill_color[1] = 0.0f;
    brush.fill_color[2] = 0.0f;
    ThreeDShapes::drawCone(650, 150, 50, 100, brush); // Σχεδίαση κώνου

    // Ορισμός χρώματος για τον κύλινδρο
    brush.fill_color[0] = 0.3f;
    brush.fill_color[1] = 1.0f;
    brush.fill_color[2] = 0.3f;
    ThreeDShapes::drawCylinder(150, 400, 40, 120, brush); // Σχεδίαση κυλίνδρου

    // Ορισμός χρώματος για τη σφαίρα
    brush.fill_color[0] = 1.0f;
    brush.fill_color[1] = 1.0f;
    brush.fill_color[2] = 0.0f;
    ThreeDShapes::drawSphere(400, 300, 50, brush); // Σχεδίαση σφαίρας

    // Ορισμός χρώματος για την πυραμίδα
    brush.fill_color[0] = 0.6f;
    brush.fill_color[1] = 0.3f;
    brush.fill_color[2] = 0.9f;
    ThreeDShapes::drawPyramid(650, 400, 80, 100, brush); // Σχεδίαση πυραμίδας

    // Ορισμός χρώματος για το πρίσμα
    brush.fill_color[0] = 1.0f;
    brush.fill_color[1] = 0.5f;
    brush.fill_color[2] = 0.0f;
    ThreeDShapes::drawPrism(400, 550, 6, 40, 80, brush); // Σχεδίαση εξαγωνικού πρίσματος
}

int main() {
    // Δημιουργία παραθύρου για τη σχεδίαση
    graphics::createWindow(WINDOW_WIDTH, WINDOW_HEIGHT, "Three-Dimensional Shapes");

    // Ορισμός της συνάρτησης σχεδίασης
    graphics::setDrawFunction(draw);

    // Εκκίνηση του κύκλου μηνυμάτων
    graphics::startMessageLoop();

    return 0;
}