#include "three_d_shapes.h" // Συμπερίληψη της βιβλιοθήκης για τα τρισδιάστατα σχήματα
#include "brush_utils.h"    // Συμπερίληψη της βιβλιοθήκης για χειρισμό του χρώματος
#include "sgg/graphics.h"   // Συμπερίληψη της βιβλιοθήκης γραφικών
#include <cmath>

// Διαστάσεις παραθύρου
const float WINDOW_WIDTH = 800;
const float WINDOW_HEIGHT = 600;

void draw() {
    graphics::Brush brush;

    // Ορισμός χρώματος για τον κύβο με τη χρήση της brush_utils
    brush_utils::setFillColor(brush, 0.2f, 0.6f, 0.8f);
    ThreeDShapes::drawCube(150, 150, 100, brush); // Σχεδίαση κύβου

    // Ορισμός χρώματος για το παραλληλεπίπεδο με τη χρήση της brush_utils
    brush_utils::setFillColor(brush, 0.8f, 0.5f, 0.2f);
    ThreeDShapes::drawCuboid(400, 150, 120, 80, 60, brush); // Σχεδίαση παραλληλεπιπέδου

    // Ορισμός χρώματος για τον κώνο
    brush_utils::setFillColor(brush, 1.0f, 0.0f, 0.0f);
    ThreeDShapes::drawCone(650, 150, 50, 100, brush); // Σχεδίαση κώνου

    // Ορισμός χρώματος για τον κύλινδρο
    brush_utils::setFillColor(brush, 0.3f, 1.0f, 0.3f);
    ThreeDShapes::drawCylinder(150, 400, 40, 120, brush); // Σχεδίαση κυλίνδρου

    // Ορισμός χρώματος για τη σφαίρα
    brush_utils::setFillColor(brush, 1.0f, 1.0f, 0.0f);
    ThreeDShapes::drawSphere(400, 300, 50, brush); // Σχεδίαση σφαίρας

    // Ορισμός χρώματος για την πυραμίδα
    brush_utils::setFillColor(brush, 0.6f, 0.3f, 0.9f);
    ThreeDShapes::drawPyramid(650, 400, 80, 100, brush); // Σχεδίαση πυραμίδας

    // Ορισμός χρώματος για το πρίσμα
    brush_utils::setFillColor(brush, 1.0f, 0.5f, 0.0f);
    ThreeDShapes::drawPrism(400, 550, 6, 40, 80, brush); // Σχεδίαση εξαγωνικού πρίσματος
}

int main() {
    // Δημιουργία παραθύρου για τη σχεδίαση
    graphics::createWindow(WINDOW_WIDTH, WINDOW_HEIGHT, "Three-Dimensional Shapes");

    // Ορισμός της συνάρτησης σχεδίασης
    graphics::setDrawFunction(draw);

    // Εκκίνηση του κύκλου μηνυμάτων
    graphics::startMessageLoop();

    return 0;
}
